
package de.ivu.elect.business.email.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.email.entity.EmailVorlage;

@RequestScoped
@Named(EmailVorlageConversationSelect.COMPONENT_NAME)
public class EmailVorlageConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "emailVorlageConversationSelect";

  @Inject
  protected transient EmailVorlageExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(EmailVorlageConversationStore.class)
  protected transient EmailVorlageConversationStore conversationStore;

  public EmailVorlageConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public EmailVorlage getEntity() {
    return getEntityInternal();
  }

  private EmailVorlage getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(EmailVorlage entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.email.entity.EmailVorlagePK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(EmailVorlage entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.email.entity.EmailVorlagePK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.email.entity.EmailVorlagePK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected EmailVorlage attach(EmailVorlage entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected EmailVorlage attach( de.ivu.elect.business.email.entity.EmailVorlagePK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
